var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import { withRouter } from 'react-router';
import PropTypes from 'prop-types';
import * as routeHelpers from './helpers';
import { Switch } from 'react-router-dom';

var _default = withRouter(_class = function (_React$Component) {
    _inherits(_default, _React$Component);

    function _default(props, context) {
        _classCallCheck(this, _default);

        var _this = _possibleConstructorReturn(this, (_default.__proto__ || Object.getPrototypeOf(_default)).call(this, props, context));

        _this.state = {
            allRoutes: routeHelpers.transformRoutes(props.routes, props.defaultLayout, function (_ref) {
                var children = _ref.children;
                return React.createElement(
                    'div',
                    null,
                    children
                );
            })
        };
        return _this;
    }

    _createClass(_default, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                NotFound = _props.notFound,
                routeWrappers = _props.routeWrappers;

            var routes = this.state.allRoutes;

            return React.createElement(
                Switch,
                null,
                routes.pageRoutes.map(function (route) {
                    return routeHelpers.generateRouteComponent({ props: route, routeId: route.routeId, routeWrappers: routeWrappers });
                }),
                NotFound && React.createElement(NotFound, null)
            );
        }
    }]);

    return _default;
}(React.Component)) || _class;

_default.propTypes = {
    routes: PropTypes.array.isRequired,
    notFound: PropTypes.func,
    defaultLayout: PropTypes.func,
    routeWrappers: PropTypes.arrayOf(PropTypes.func)
};
export { _default as default };