var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import { Switch } from 'react-router-dom';
import PropTypes from 'prop-types';

import { isLayerPage, generateRouteComponent } from './helpers';

var _default = function (_React$Component) {
    _inherits(_default, _React$Component);

    function _default() {
        _classCallCheck(this, _default);

        return _possibleConstructorReturn(this, (_default.__proto__ || Object.getPrototypeOf(_default)).apply(this, arguments));
    }

    _createClass(_default, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps) {
            var location = nextProps.location,
                routes = nextProps.routes;

            var _ref = location.state || {},
                returnToPage = _ref.returnToPage;

            return !isLayerPage(routes.layerRoutes, location) && !returnToPage;
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                routes = _props.routes,
                pageLocation = _props.pageLocation,
                routeWrappers = _props.routeWrappers,
                NotFound = _props.notFound;


            return React.createElement(
                Switch,
                { location: pageLocation },
                routes.pageRoutes.map(function (route) {
                    return generateRouteComponent({ props: route, routeId: route.routeId, routeWrappers: routeWrappers });
                }),
                NotFound && React.createElement(NotFound, null)
            );
        }
    }]);

    return _default;
}(React.Component);

_default.propTypes = {
    routes: PropTypes.shape({
        pageRoutes: PropTypes.array.isRequired,
        layerRoutes: PropTypes.array.isRequired
    }),
    notFound: PropTypes.func,
    pageLocation: PropTypes.object.isRequired,
    location: PropTypes.object.isRequired,
    routeWrappers: PropTypes.arrayOf(PropTypes.func)
};
export { _default as default };